// q2chwmBoardView.cpp : t@C
//

#include "stdafx.h"
#include "q2chwm.h"
#include "q2chwmBoardView.h"
#include "q2chwmConfig.h"
#include "q2chwmArticleFile.h"
#include "YoTime.h"

// Cq2chwmBoardView

IMPLEMENT_DYNCREATE(Cq2chwmBoardView, CTreeView)

Cq2chwmBoardView::Cq2chwmBoardView()
{
	m_pFont = NULL;
	m_bo_running = FALSE;
}

Cq2chwmBoardView::~Cq2chwmBoardView()
{
	if (m_pFont != NULL) delete m_pFont;
}

BEGIN_MESSAGE_MAP(Cq2chwmBoardView, CTreeView)
	ON_WM_DESTROY()
	ON_NOTIFY_REFLECT(NM_RETURN, &Cq2chwmBoardView::OnNMReturn)
	ON_WM_KEYDOWN()
	ON_COMMAND(ID_RELOAD, &Cq2chwmBoardView::OnReload)
	ON_COMMAND(ID_GOBOTTOM, &Cq2chwmBoardView::OnGobottom)
	ON_COMMAND(ID_GOTOP, &Cq2chwmBoardView::OnGotop)
	ON_WM_CHAR()
	ON_WM_PAINT()
END_MESSAGE_MAP()


// Cq2chwmBoardView ff

#ifdef _DEBUG
void Cq2chwmBoardView::AssertValid() const
{
	CTreeView::AssertValid();
}

#ifndef _WIN32_WCE
void Cq2chwmBoardView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}
#endif
#endif //_DEBUG


// Cq2chwmBoardView bZ[W nh

void Cq2chwmBoardView::OnInitialUpdate()
{
	CTreeView::OnInitialUpdate();

	// TODO: ɓȃR[hǉ邩A͊{NXĂяoĂB
	SetFont();
	SetColor();
	LONG lo_style = ::GetWindowLong(GetTreeCtrl().m_hWnd, GWL_STYLE);
	::SetWindowLong(GetTreeCtrl().m_hWnd, GWL_STYLE, lo_style|TVS_HASLINES|TVS_HASBUTTONS|TVS_LINESATROOT);
	HTREEITEM hItem = GetTreeCtrl().InsertItem(_T("q2chwm"));
	m_hItemBookmark = GetTreeCtrl().InsertItem(_T("ubN}[N"), hItem);
	m_hItemCache = GetTreeCtrl().InsertItem(_T("LbV"), hItem);
	m_hItemFind2ch = GetTreeCtrl().InsertItem(_T("Q˂錟"), hItem);
	m_hItemEtc = GetTreeCtrl().InsertItem(_T("̑"));

	// board.txtr[쐬
	if (m_cBoardFile.Exist() == FALSE) {
		// 擾邩₢킹
		if (::MessageBox(m_hWnd, _T("ꗗ݂܂BT[o擾܂H"), _T(APP_NAME)_T("/")_T(APP_VERSION), MB_YESNO|MB_ICONQUESTION) == IDYES) {
			CreateFromHttp(Cq2chwmConfig::GetInstance()->GetBoardUrl());
		}
	} else {
		// r[쐬
		CreateFromFile();
	}

	// Ƃ肠
	GoTop();
}

BOOL Cq2chwmBoardView::CreateFromFile()
{
	CYoTime cTime;
	PRINTLOG("start %d(msec)", cTime.Elapsed());
	int in_ret = m_cBoardFile.CreateFromFile();
	if (in_ret != ERR_NONE) {
		::MessageBox(m_hWnd, _T("ꗗt@C̓ǂݍ݂Ɏs܂B"), _T(APP_NAME)_T("/")_T(APP_VERSION), MB_OK|MB_ICONSTOP);
		return FALSE;
	}
	PRINTLOG("end %d(msec)", cTime.Elapsed());

	// c[쐬
	createTree();
	PRINTLOG("createTree end %d(msec)", cTime.Elapsed());

	// ̑쐬
	if (m_cBoardFileEtc.Exist() == TRUE) {
		in_ret = m_cBoardFileEtc.CreateFromFile();
		if (in_ret != ERR_NONE) {
			::MessageBox(m_hWnd, _T("̑t@C̓ǂݍ݂Ɏs܂B"), _T(APP_NAME)_T("/")_T(APP_VERSION), MB_OK|MB_ICONSTOP);
			return FALSE;
		}
		createTreeEtc();
	}

	return TRUE;
}

BOOL Cq2chwmBoardView::CreateFromHttp(
	const char *chp_url)
{
	if (m_bo_running == TRUE) return TRUE;
	m_bo_running = TRUE;
	GetParent()->SendMessage(WM_USER_SHOWSTATUSBAR, 0, (LPARAM)TRUE);
	int in_ret = m_cBoardFile.CreateFromHttp(chp_url);
	if (in_ret != ERR_NONE) {
		// G[
		GetParent()->SendMessage(WM_USER_SHOWSTATUSBAR, 0, (LPARAM)FALSE);
		m_bo_running = FALSE;
		return FALSE;
	}

	// ړ]o
	DetectRemoval();

	// c[쐬
	createTree();
	GetParent()->SendMessage(WM_USER_SHOWSTATUSBAR, 0, (LPARAM)FALSE);
	m_bo_running = FALSE;

	return TRUE;
}

BOOL Cq2chwmBoardView::ReloadEtc()
{
	// ̑쐬
	if (m_cBoardFileEtc.Exist() == TRUE) {
		clearTreeEtc();
		int in_ret = m_cBoardFileEtc.CreateFromFile();
		if (in_ret != ERR_NONE) {
			::MessageBox(m_hWnd, _T("̑t@C̓ǂݍ݂Ɏs܂B"), _T(APP_NAME)_T("/")_T(APP_VERSION), MB_OK|MB_ICONSTOP);
			return FALSE;
		}
		createTreeEtc();
	}
	return TRUE;
}

BOOL Cq2chwmBoardView::DetectRemoval()
{
	// obNAbvt@Cǂݍ
	CYoString str_filename = m_cBoardFile.GetFileName();
	str_filename += ".bak";
	Cq2chwmBoardFile cBoardFileBak(str_filename);
	cBoardFileBak.CreateFromFile();

	BOOL bo_err = FALSE;
	CYoString str_msg;
	str_msg = "ړ]ŃG[܂B\n";
	for (int i = 0; i < cBoardFileBak.Rows(); i++) {
		// IDURLTĈړ]o
		int in_index = m_cBoardFile.SearchFromId(cBoardFileBak.GetId(i));
		if (in_index >= 0) {
			const char *chp_url_new = m_cBoardFile.GetUrl(in_index);
			const char *chp_url_old = cBoardFileBak.GetUrl(i);
			if (strcmp(chp_url_new, chp_url_old) != 0) {
				// ړ]o
				if (MergeDirectory(chp_url_old, chp_url_new) == FALSE) {
					// G[
					bo_err = TRUE;
					str_msg.FormatAdd("%s -> %s\n", chp_url_old, chp_url_new);
				}
			}
		}
	}

	if (bo_err == TRUE) {
		CString cstr_msg;
		cstr_msg = (const char*)str_msg;
		AfxMessageBox(cstr_msg);
	}

	return TRUE;
}

BOOL Cq2chwmBoardView::MergeDirectory(
	const char *chp_src,
	const char *chp_dst)
{
	CYoString str_path_src = UrlToPath(chp_src);
	CYoString str_path_dst = UrlToPath(chp_dst);

	// article-summary̓}[WȂ̂œǂݍł
	Cq2chwmArticleFile cFileSrc;
	cFileSrc.Create(chp_src);
	Cq2chwmArticleFile cFileDst;
	cFileDst.Create(chp_dst);
	cFileDst.AddArticle(cFileSrc);

	// Rs[(chp_src->chp_dst)
	MakeDirectory(str_path_dst);
	if (CopyDirectory(str_path_src, str_path_dst) == FALSE) {
		return FALSE;
	}

	// article-summary
	cFileDst.Write();

	// Rs[폜
	if (RemoveDirectory((const char*)str_path_src) == FALSE) {
		return FALSE;
	}

	return TRUE;
}

void Cq2chwmBoardView::clearTree()
{
	HTREEITEM hItem = GetTreeCtrl().GetRootItem();
	while (hItem != NULL) {
		Cq2chwmBoardItem *pItem = (Cq2chwmBoardItem*)GetTreeCtrl().GetItemData(hItem);
		if (pItem == NULL) {
			hItem = GetTreeCtrl().GetNextItem(hItem, TVGN_NEXT);
		} else {
			delete pItem;
			HTREEITEM hItemChild = GetTreeCtrl().GetChildItem(hItem);
			while (hItemChild != NULL) {
				Cq2chwmBoardItem *pItem = (Cq2chwmBoardItem*)GetTreeCtrl().GetItemData(hItemChild);
				if (pItem != NULL) delete pItem;
				hItemChild = GetTreeCtrl().GetNextItem(hItemChild, TVGN_NEXT);
			}
			HTREEITEM hItemOld = hItem;
			hItem = GetTreeCtrl().GetNextItem(hItem, TVGN_NEXT);
			GetTreeCtrl().DeleteItem(hItemOld);
		}
	}
}

void Cq2chwmBoardView::clearTreeEtc()
{
	HTREEITEM hItem = GetTreeCtrl().GetChildItem(m_hItemEtc);
	while (hItem != NULL) {
		Cq2chwmBoardItem *pItem = (Cq2chwmBoardItem*)GetTreeCtrl().GetItemData(hItem);
		delete pItem;
		HTREEITEM hItemOld = hItem;
		hItem = GetTreeCtrl().GetNextItem(hItem, TVGN_NEXT);
		GetTreeCtrl().DeleteItem(hItemOld);
	}
}

#define BITWEENNAMETOURL	"                        "
void Cq2chwmBoardView::createTree()
{
	clearTree();
	HTREEITEM hItemParent = NULL;
	HTREEITEM hItemAbove = NULL;
	for (int i = 0; i < m_cBoardFile.Rows(); i++) {
		Cq2chwmBoardItem *pItem = new Cq2chwmBoardItem(m_cBoardFile.GetName(i), m_cBoardFile.GetUrl(i), m_cBoardFile.GetId(i));
		CString cstr_name;
		if (strlen(m_cBoardFile.GetUrl(i)) == 0) {
			// e
			cstr_name = m_cBoardFile.GetName(i);
			hItemParent = GetTreeCtrl().InsertItem(TVIF_PARAM|TVIF_TEXT, cstr_name, -1, -1, 0, 0, (LPARAM)pItem, NULL, hItemAbove);
		} else {
			// q
			cstr_name.Format(_T("%s%s%s"), W(m_cBoardFile.GetName(i)), _T(BITWEENNAMETOURL), W(m_cBoardFile.GetId(i)));
			hItemAbove = GetTreeCtrl().InsertItem(TVIF_PARAM|TVIF_TEXT, cstr_name, -1, -1, 0, 0, (LPARAM)pItem, hItemParent, hItemAbove);
		}
	}
}

void Cq2chwmBoardView::createTreeEtc()
{
	clearTreeEtc();
	HTREEITEM hItemAbove = NULL;
	for (int i = 0; i < m_cBoardFileEtc.Rows(); i++) {
		Cq2chwmBoardItem *pItem = new Cq2chwmBoardItem(m_cBoardFileEtc.GetName(i), m_cBoardFileEtc.GetUrl(i), m_cBoardFileEtc.GetId(i));
		CString cstr_name;
		cstr_name.Format(_T("%s%s%s"), W(m_cBoardFileEtc.GetName(i)), _T(BITWEENNAMETOURL), W(m_cBoardFileEtc.GetId(i)));
		hItemAbove = GetTreeCtrl().InsertItem(TVIF_PARAM|TVIF_TEXT, cstr_name, -1, -1, 0, 0, (LPARAM)pItem, m_hItemEtc, hItemAbove);
	}
}

void Cq2chwmBoardView::OnDestroy()
{
	clearTreeEtc();
	clearTree();
	CTreeView::OnDestroy();

	// TODO: ɃbZ[W nh R[hǉ܂B
}

void Cq2chwmBoardView::OnNMReturn(NMHDR *pNMHDR, LRESULT *pResult)
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	HTREEITEM hItem = GetTreeCtrl().GetSelectedItem();
	if (GetTreeCtrl().ItemHasChildren(hItem) == TRUE) {
		// q2chwm
		GetTreeCtrl().Expand(hItem, TVE_TOGGLE);
	} else if (hItem == m_hItemBookmark) {
		GetParent()->SendMessage(WM_USER_OPENBOOKMARK, 0, 0);
	} else if (hItem == m_hItemFind2ch) {
		GetParent()->SendMessage(WM_USER_OPENFIND2CH, 0, 0);
	} else if (hItem == m_hItemCache) {
		GetParent()->SendMessage(WM_USER_OPENCACHE, 0, 0);
	} else {
		Cq2chwmBoardItem *pItem = (Cq2chwmBoardItem*)GetTreeCtrl().GetItemData(hItem);
		GetParent()->SendMessage(WM_USER_BOARDCLICKED, 0, (LPARAM)pItem);
	}
	*pResult = 0;
}

void Cq2chwmBoardView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	TRACE(_T("Cq2chwmBoardView::OnKeyDown: %02x(%d)\n"), nChar, nChar);
	if (nChar == Cq2chwmConfig::GetInstance()->GetKeyCancel()) {
		GetParent()->SendMessage(WM_USER_CANCEL, 0, 0);
		return;
	} else if (nChar == Cq2chwmConfig::GetInstance()->GetKeyBottom()) {
		GoBottom();
		return;
	} else if (nChar == Cq2chwmConfig::GetInstance()->GetKeyTop()) {
		GoTop();
		return;
	} else if (nChar == Cq2chwmConfig::GetInstance()->GetKeyReload()) {
		OnReload();
		return;
	}

	CTreeView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void Cq2chwmBoardView::SetFont()
{
	CString cstr_name;
	cstr_name = Cq2chwmConfig::GetInstance()->GetFontNameList();
	if (m_pFont != NULL) delete m_pFont;
	m_pFont = new CFont();
	m_pFont->CreatePointFont(Cq2chwmConfig::GetInstance()->GetFontSizeList() * 10, cstr_name);
	CWnd::SetFont(m_pFont);
}

void Cq2chwmBoardView::SetColor()
{
#ifndef _WIN32_WCE
	//GetTreeCtrl().SetBkColor(Cq2chwmConfig::GetInstance()->GetColorBack());
	//GetTreeCtrl().SetTextColor(Cq2chwmConfig::GetInstance()->GetColorFore());
#endif
}

void Cq2chwmBoardView::OnReload()
{
	// TODO: ɃR}h nh R[hǉ܂B
	CreateFromHttp(Cq2chwmConfig::GetInstance()->GetBoardUrl());
	InvalidateRect(NULL);
}

void Cq2chwmBoardView::GoTop()
{
	HTREEITEM hItemRoot= GetTreeCtrl().GetRootItem();
	GetTreeCtrl().SelectItem(hItemRoot);
	GetTreeCtrl().EnsureVisible(hItemRoot);
}

void Cq2chwmBoardView::GoBottom()
{
	HTREEITEM hItem;
	HTREEITEM hItemTmp = GetTreeCtrl().GetRootItem();
	while ((hItemTmp = GetTreeCtrl().GetNextItem(hItemTmp, TVGN_NEXT)) != NULL) {
		hItem = hItemTmp;
	}
	GetTreeCtrl().Select(hItem, TVGN_CARET);
}

void Cq2chwmBoardView::OnGobottom()
{
	// TODO: ɃR}h nh R[hǉ܂B
	GoBottom();
}

void Cq2chwmBoardView::OnGotop()
{
	// TODO: ɃR}h nh R[hǉ܂B
	GoTop();
}

void Cq2chwmBoardView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	return;
	CTreeView::OnChar(nChar, nRepCnt, nFlags);
}

void Cq2chwmBoardView::OnPaint()
{
	PAINTSTRUCT ps;
	CDC* pDC = BeginPaint(&ps);
	//CPaintDC cDC(this); // device context for painting
	//CWnd::DefWindowProc(WM_PAINT, (WPARAM)pDC->m_hDC, 0);
	//return;

	// TODO: ɃbZ[W nh R[hǉ܂B
	// `惁bZ[W CTreeView::OnPaint() ĂяoȂłB
	// ftHg̕`揈
	// WM_PAINTbZ[Wł́AwParamɕ`ȂfoCXReLXg̃nhw肷
	RECT rcView;
	GetClientRect(&rcView);
	CDC cMemDC;
	cMemDC.CreateCompatibleDC(pDC);
	CBitmap cBitmap;
	cBitmap.CreateCompatibleBitmap(pDC, rcView.right, rcView.bottom);
	CBitmap *pOldBitmap = cMemDC.SelectObject(&cBitmap);

	// m[h`
	CWnd::DefWindowProc(WM_PAINT, (WPARAM)cMemDC.m_hDC, 0);

	// c[Rg[̃tHg擾A
	// foCXReLXg̃tHgƂĐݒ肷
	LOGFONT stLogFont;
	CFont cFont;
	GetFont()->GetLogFont(&stLogFont);
	cFont.CreateFontIndirect(&stLogFont);
	CFont* pOldFont = cMemDC.SelectObject(&cFont);

	// ׂẴACeɂăeLXg`悵Ȃ
	HTREEITEM hItem = GetTreeCtrl().GetFirstVisibleItem();
	do
	{
		CRect rcItem;
		GetTreeCtrl().GetItemRect(hItem, &rcItem, TRUE);
		if (rcItem.bottom < ps.rcPaint.top ||
			rcItem.top > ps.rcPaint.bottom)
		{
			continue;
		}
		rcItem.right = rcView.right;

		// wiNA
		CBrush cBrush(Cq2chwmConfig::GetInstance()->GetColorBack());
		cMemDC.FillRect(&rcItem, &cBrush);

		// `FƔwiFݒ
		if( hItem == GetTreeCtrl().GetDropHilightItem() ||
			(hItem == GetTreeCtrl().GetSelectedItem() && GetTreeCtrl().GetDropHilightItem() == NULL) )
		{
			cMemDC.SetBkColor(Cq2chwmConfig::GetInstance()->GetColorBack());
			cMemDC.SetTextColor(Cq2chwmConfig::GetInstance()->GetColorActive());
		}
		else
		{
			cMemDC.SetBkColor(Cq2chwmConfig::GetInstance()->GetColorBack());
			cMemDC.SetTextColor(Cq2chwmConfig::GetInstance()->GetColorFore());
		}

		// ACẽeLXg擾A`悷
		CString strText = GetTreeCtrl().GetItemText(hItem);
		int iFind = strText.ReverseFind(_T(' '));
		if (iFind >= 0) {
			CString strName;
			CString strUrl;
			strName = strText.Left(iFind);
			strUrl = strText.Right(strText.GetLength() - iFind - 1);
			cMemDC.ExtTextOutW(rcItem.left + 2, rcItem.top + 1, 0, &rcItem, strName, NULL);
			CSize szBuff = cMemDC.GetTextExtent(_T(BITWEENNAMETOURL));
			cMemDC.ExtTextOutW(rcItem.left + 2 + szBuff.cx, rcItem.top + 1, 0, &rcItem, strUrl, NULL);
		} else {
			cMemDC.ExtTextOutW(rcItem.left + 2, rcItem.top + 1, 0, &rcItem, strText, NULL);
		}

	} while(hItem = GetTreeCtrl().GetNextVisibleItem(hItem));

	// ]
	pDC->BitBlt(ps.rcPaint.left, ps.rcPaint.top, ps.rcPaint.right, ps.rcPaint.bottom, &cMemDC, ps.rcPaint.left, ps.rcPaint.top, SRCCOPY);

	// foCXReLXg̃tHgɖ߂
	cMemDC.SelectObject(pOldBitmap);
	cMemDC.SelectObject(pOldFont);
	cFont.DeleteObject();
	cBitmap.DeleteObject();
	cMemDC.DeleteDC();
	EndPaint(&ps);
}

BOOL Cq2chwmBoardView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ɓȃR[hǉ邩A͊{NXĂяoĂB
	cs.style |= WS_HSCROLL;
	return CTreeView::PreCreateWindow(cs);
}

BOOL Cq2chwmBoardView::SearchNext(
	const char *chp_word)
{
	CYoRegex cRegex(chp_word, CYoRegex::SJIS, TRUE);
	HTREEITEM hItem;
	if (GetTreeCtrl().GetSelectedItem() == NULL) {
		// IȂ
		hItem = GetTreeCtrl().GetRootItem();
	} else if (GetTreeCtrl().ItemHasChildren(GetTreeCtrl().GetSelectedItem()) == TRUE) {
		// eI
		hItem = GetTreeCtrl().GetChildItem(GetTreeCtrl().GetSelectedItem());
	} else {
		// qI
		hItem = GetTreeCtrl().GetNextItem(GetTreeCtrl().GetSelectedItem(), TVGN_NEXT);
		if (hItem == NULL) {
			hItem = GetTreeCtrl().GetNextItem(GetTreeCtrl().GetParentItem(GetTreeCtrl().GetSelectedItem()), TVGN_NEXT);
		}
	}
	while (hItem != NULL) {
		Cq2chwmBoardItem *pItem = (Cq2chwmBoardItem*)GetTreeCtrl().GetItemData(hItem);
		if (pItem == NULL || strlen(pItem->GetUrl()) == 0) {
			if (GetTreeCtrl().ItemHasChildren(hItem) == TRUE) {
				// eACe
				hItem = GetTreeCtrl().GetChildItem(hItem);
			} else {
				// q2chJeSACe
				HTREEITEM hItemTmp = GetTreeCtrl().GetNextItem(hItem, TVGN_NEXT);
				if (hItemTmp == NULL) {
					// eACe̎̃ACe
					hItem = GetTreeCtrl().GetNextItem(GetTreeCtrl().GetParentItem(hItem), TVGN_NEXT);
				} else {
					hItem = hItemTmp;
				}
			}
		} else {
			if (cRegex.Match(pItem->GetName()) >= 0 || cRegex.Match(pItem->GetId()) >= 0) {
				GetTreeCtrl().SelectItem(hItem);
				GetTreeCtrl().EnsureVisible(hItem);
				return TRUE;
			}
			HTREEITEM hItemTmp = GetTreeCtrl().GetNextItem(hItem, TVGN_NEXT);
			if (hItemTmp == NULL) {
				// ̐eACe
				hItem = GetTreeCtrl().GetNextItem(GetTreeCtrl().GetParentItem(hItem), TVGN_NEXT);
			} else {
				// ̎qACe
				hItem = hItemTmp;
			}
		}
	}
	::MessageBox(m_hWnd, _T("Ō܂Ō܂"), _T(APP_NAME)_T("/")_T(APP_VERSION), MB_OK|MB_ICONINFORMATION);
	return TRUE;
}

HTREEITEM Cq2chwmBoardView::getBottomItem(
	HTREEITEM hItemParent)
{
	if (hItemParent == NULL) {
		hItemParent = GetTreeCtrl().GetRootItem();

		// eACȅI[ֈړ
		HTREEITEM hItemTmp = hItemParent;
		while (hItemTmp != NULL) {
			hItemParent = hItemTmp;
			hItemTmp = GetTreeCtrl().GetNextItem(hItemTmp, TVGN_NEXT);
		}
	}

	// eACe̍ŏ̎qACe擾
	HTREEITEM hItemChild = GetTreeCtrl().GetChildItem(hItemParent);
	if (hItemChild == NULL) return hItemParent;

	// qACȅI[ֈړ
	HTREEITEM hItem;
	HTREEITEM hItemTmp = hItemChild;
	while (hItemTmp != NULL) {
		hItem = hItemTmp;
		hItemTmp = GetTreeCtrl().GetNextItem(hItemTmp, TVGN_NEXT);
	}

	return hItem;
}

BOOL Cq2chwmBoardView::SearchPrev(
	const char *chp_word)
{
	CYoRegex cRegex(chp_word, CYoRegex::SJIS, TRUE);
	HTREEITEM hItem;
	if (GetTreeCtrl().GetSelectedItem() == NULL) {
		// IȂ
		hItem = getBottomItem();
	} else if (GetTreeCtrl().ItemHasChildren(GetTreeCtrl().GetSelectedItem()) == TRUE) {
		// eI
		hItem = getBottomItem(GetTreeCtrl().GetNextItem(GetTreeCtrl().GetSelectedItem(), TVGN_PREVIOUS));
	} else {
		// qI
		hItem = GetTreeCtrl().GetNextItem(GetTreeCtrl().GetSelectedItem(), TVGN_PREVIOUS);
		if (hItem == NULL) {
			hItem = GetTreeCtrl().GetParentItem(GetTreeCtrl().GetSelectedItem());
		}
	}
	
	while (hItem != NULL) {
		Cq2chwmBoardItem *pItem = (Cq2chwmBoardItem*)GetTreeCtrl().GetItemData(hItem);
		if (pItem == NULL || strlen(pItem->GetUrl()) == 0) {
			if (GetTreeCtrl().ItemHasChildren(hItem) == TRUE) {
				// eACe
				hItem = getBottomItem(GetTreeCtrl().GetNextItem(hItem, TVGN_PREVIOUS));
			} else {
				// q2chJeSACe
				hItem = GetTreeCtrl().GetNextItem(hItem, TVGN_PREVIOUS);
			}
		} else {
			if (cRegex.Match(pItem->GetName()) >= 0 || cRegex.Match(pItem->GetId()) >= 0) {
				GetTreeCtrl().SelectItem(hItem);
				GetTreeCtrl().EnsureVisible(hItem);
				return TRUE;
			}
			HTREEITEM hItemTmp = GetTreeCtrl().GetNextItem(hItem, TVGN_PREVIOUS);
			if (hItemTmp == NULL) {
				// ̐eACe
				hItem = GetTreeCtrl().GetParentItem(hItem);
			} else {
				// ̎qACe
				hItem = hItemTmp;
			}
		}
	}
	::MessageBox(m_hWnd, _T("Ō܂Ō܂"), _T(APP_NAME)_T("/")_T(APP_VERSION), MB_OK|MB_ICONINFORMATION);
	return TRUE;
}

