#include "StdAfx.h"
#include "YoHttpClient.h"
#include "MainFrm.h"
#include "q2chwmCommon.h"
#include "q2chwmBoardFile.h"
#include "q2chwmConfig.h"

Cq2chwmBoardFileEtc::Cq2chwmBoardFileEtc() : Cq2chwmBoardFile()
{
	m_str_filename = Cq2chwmConfig::GetInstance()->GetRootDirectory();
	m_str_filename += "\\etc.txt";
}

Cq2chwmBoardFile::Cq2chwmBoardFile(
	const char *chp_filename)
{
	if (chp_filename == NULL) {
		m_str_filename = Cq2chwmConfig::GetInstance()->GetRootDirectory();
		m_str_filename += "\\board.txt";
	} else {
		m_str_filename = chp_filename;
	}
}

Cq2chwmBoardFile::~Cq2chwmBoardFile()
{
}

int Cq2chwmBoardFile::CreateFromFile()
{
	RemoveAll();
	CYoTextFile cFile(m_str_filename, CYoFile::READ);
	if (cFile.Open() == FALSE) return ERR_FILE_OPEN;
	CYoString str_line;
	CYoRegex cRegex("`bg|c[|̃TCg", CYoRegex::SJIS);
	while (cFile.Eof() == FALSE) {
		cFile.ReadLine(str_line);
		str_line.Trim();
		// 3sZbgœǂ
		CYoString str_name = str_line;
		cFile.ReadLine(str_line);
		str_line.Trim();
		if (cFile.Eof() == TRUE) break;
		CYoString str_url = str_line;
		cFile.ReadLine(str_line);
		str_line.Trim();
		if (cFile.Eof() == TRUE) break;
		CYoString str_key = str_line;

		if (cRegex.Match(str_name) == -1) {
			Add((const char *)str_name, (const char*)str_url, (const char*)str_key, NULL);
		}
	}
	cFile.Close();

	return ERR_NONE;
}

int Cq2chwmBoardFile::CreateFromHttp(
	const char *chp_url)
{
	RemoveAll();
	CYoHttpClient cHttp(chp_url);
	// WILLCOM̍T[rXAccept-Encoding: gzipƂ܂htmlȂ̂?
	cHttp.SetGzipEncoding(FALSE);
	cHttp.SetUserAgent(Cq2chwmConfig::GetInstance()->GetUserAgent());
	if (Cq2chwmConfig::GetInstance()->GetProxyUse() == TRUE) {
		cHttp.SetProxy(Cq2chwmConfig::GetInstance()->GetProxyHost(), Cq2chwmConfig::GetInstance()->GetProxyPort());
		cHttp.SetProxyAuth(Cq2chwmConfig::GetInstance()->GetProxyId(), Cq2chwmConfig::GetInstance()->GetProxyPass());
	}
	cHttp.SetCallbackProc(CMainFrame::CallbackProc, AfxGetMainWnd());

	if (cHttp.Connect(TIMEOUT) == FALSE) {
		return ERR_HTTP_CONNECT;
	}

	if (cHttp.Get() == FALSE) {
		return ERR_HTTP_GET;
	}

	if (cHttp.GetResultCode() < 200 || cHttp.GetResultCode() >= 300) {
		return ERR_HTTP_GET;
	}

	// bbsmenu.htmlɕێ
	CYoString str_html;
	{
		CYoString str_length = cHttp.GetResponseHeader("Content-Length");
		int in_length = str_length.Atoi();
		int in_recv = 0;

		char cha_buff[RECV_BUFF];
		int in_ret;
		while ((in_ret = cHttp.Recv(cha_buff, sizeof(cha_buff) - 1)) > 0) {
			str_html.StrnCat(cha_buff, in_ret);
			in_recv += in_ret;
			AfxGetMainWnd()->SendMessage(WM_USER_SETPROGRESS, cHttp.GetRecvSize(), in_length);
			cha_buff[in_ret] = 0x00;
			PRINTLOG("%s[%d]", cha_buff, in_ret);
		}
		if (in_ret == 0 && ((CMainFrame*)AfxGetMainWnd())->Canceled() == TRUE) {
			return ERR_CANCELED;
		}
		if( in_ret == SOCKET_ERROR ){
			return ERR_HTTP_RECV;
		}
	}

	Backup();

	// board.txt쐬
	CString cstr_filename;
	cstr_filename = m_str_filename;
	CFile cFile;
	if (cFile.Open(cstr_filename, CFile::modeCreate|CFile::modeWrite) == FALSE) {
		return ERR_FILE_OPEN;
	}

	CYoRegex cRegexParent("<BR><B>([^<]+)</B><BR>", CYoRegex::SJIS, TRUE);
	CYoRegex cRegexChild("<A HREF=(http://[^/>]+/([^/>]+)/)>([^<]+)</A>", CYoRegex::SJIS, TRUE);
	CYoRegex cRegexChildMachi("<A HREF=(http://[^/>]+/([^/>]+)/) TARGET=_blank>([^<]+)</A>", CYoRegex::SJIS, TRUE); // ܂aar
	const char *chp_sta = str_html;
	int in_ret;
	while ((in_ret = cRegexParent.Match(chp_sta)) >= 0) {
		// e
		char *chp_parent_name = cRegexParent.Get(1);
		cFile.Write(chp_parent_name, strlen(chp_parent_name));
		// siLF)R
		char *chp_lf = LF""LF""LF;
		cFile.Write(chp_lf, strlen(chp_lf));

		// q̌Jn
		chp_sta += in_ret + strlen(cRegexParent.Get(0));
		while (1) {
			// 2ch̔Ƃ܂BBS̔
			CYoRegex *pRegexChilds[] = {&cRegexChild, &cRegexChildMachi};
			CYoRegex *pRegex;
			int in_ret_child;
			for (int i = 0; i < sizeof(pRegexChilds) / sizeof(pRegexChilds[0]); i++) {
				in_ret_child = pRegexChilds[i]->Match(chp_sta);
				if (in_ret_child >= 0) {
					pRegex = pRegexChilds[i];
					break;
				}
			}

			// qȂȂI
			if (in_ret_child == -1) {
				break;
			}

			// qeɌI
			int in_next_parent = cRegexParent.Match(chp_sta);
			if (in_next_parent >= 0 && in_ret_child > in_next_parent) {
				break;
			}

			// q
			char *chp_name = pRegex->Get(3);
			char *chp_url = pRegex->Get(1);
			char *chp_dir = pRegex->Get(2);
			chp_lf = LF;
			cFile.Write(chp_name, strlen(chp_name));
			cFile.Write(chp_lf, strlen(chp_lf));
			cFile.Write(chp_url, strlen(chp_url));
			cFile.Write(chp_lf, strlen(chp_lf));
			cFile.Write(chp_dir, strlen(chp_dir));
			cFile.Write(chp_lf, strlen(chp_lf));

			chp_sta += in_ret_child + strlen(pRegex->Get(0));
		}
	}
	cFile.Close();

	return CreateFromFile();
}

int Cq2chwmBoardFile::SearchFromUrl(
	const char *chp_url)
{
	return CYoTable::Search(chp_url, 1, TRUE);
}

int Cq2chwmBoardFile::SearchFromId(
	const char *chp_id)
{
	return CYoTable::Search(chp_id, 2, TRUE);
}

BOOL Cq2chwmBoardFile::Exist()
{
	return ExistFile(m_str_filename);
}

#define FORMAT "%s\n%s\n%s\n"
int Cq2chwmBoardFile::Write()
{
	CFile cFile;
	CString cstr_filename;
	cstr_filename = GetFileName();
	if (cFile.Open(cstr_filename, CFile::modeCreate|CFile::modeWrite) == FALSE) {
		return ERR_FILE_OPEN;
	}
	CYoString str_fmt;
	CYoString str_name;

	for( int i = 0;i < Rows(); i++ ){
		str_name = GetBoardName(i);
		if(strlen(GetBoardUrl(i)) == 0) {
			// e
			str_fmt.Format(FORMAT, (const char*)str_name, "", "");
		}
		else
		{
			str_fmt.Format(FORMAT, (char*)str_name, GetBoardUrl(i), GetBoardId(i));
		}
		cFile.Write((char*)str_fmt, str_fmt.Length());
	}
	cFile.Close();
	return ERR_NONE;
}

void Cq2chwmBoardFile::AddBoard(
	const char *chp_name,
	const char *chp_url,
	const char *chp_id)
{
	Add(chp_name, chp_url, chp_id, NULL);
}

void Cq2chwmBoardFile::InsertBoard(
	const char *chp_name,
	const char *chp_url,
	const char *chp_id)
{
	Insert(0, chp_name, chp_url, chp_id, NULL);
}

BOOL Cq2chwmBoardFile::Replace(
	const char *chp_burl_old,
	const char *chp_burl_new)
{
	if (chp_burl_old == NULL || chp_burl_new == NULL) return FALSE;
	for( int i = 0;i < Rows(); i++ ){
		if (strcmp(chp_burl_old, GetBoardUrl(i)) == 0) {
			Update(i, 1, chp_burl_new);
		}
	}

	return TRUE;
}

BOOL Cq2chwmBoardFile::Backup()
{
	// obNAbvt@C쐬(board.txt -> board.txt.bak)
	CYoString str_filename_bak = BackupFileName();
	return RenameFile(m_str_filename, str_filename_bak);
}

CYoString Cq2chwmBoardFile::BackupFileName()
{
	CYoString str_filename_bak = m_str_filename + ".bak";
	return str_filename_bak;
}
