#include "StdAfx.h"
#include "q2chwmListItem.h"
#include "q2chwmCommon.h"

Cq2chwmListItem::Cq2chwmListItem(
	int in_index,
	const char *chp_aname,
	const char *chp_aid,
	const char *chp_bname,
	const char *chp_bid,
	const char *chp_burl,
	BOOL bo_html_to_text) :		// XbhƔHTMLfR[h邩ǂ̃tO(TRUEȂHTMLfR[h)
	m_str_aname(chp_aname),
	m_str_aid(chp_aid),
	m_str_bname(chp_bname),
	m_str_burl(chp_burl),
	m_str_bid(chp_bid)
{
	m_in_index = in_index;
	m_bo_cache = FALSE;
	m_bo_new = FALSE;
	m_bo_new_thread = FALSE;
	m_bo_search = FALSE;
	m_bo_error = FALSE;
	if (bo_html_to_text == TRUE) {
		HtmlToText(m_str_aname);
		HtmlToText(m_str_bname);
	}
	m_dbl_count_per_day = -1;

		// 쐬
	if (chp_aid != NULL) {
		time_t tm_adate = atoi(chp_aid);
		struct tm *stp_tm = localtime(&tm_adate);
		sprintf(m_cha_adate, "%04d/%02d/%02d %02d:%02d", stp_tm->tm_year + 1900, stp_tm->tm_mon + 1, stp_tm->tm_mday, stp_tm->tm_hour, stp_tm->tm_min);
	}
}

Cq2chwmListItem::~Cq2chwmListItem(void)
{
}

const char *Cq2chwmListItem::GetFileName()
{
	if (m_str_filename.Length() == 0) {
		m_str_filename = UrlToPath(m_str_burl);
		m_str_filename += "\\" + m_str_aid + ".dat";
	}
	return m_str_filename;
}

const char *Cq2chwmListItem::GetArticleUrl()
{
	if (m_str_aurl.Length() == 0) {
		m_str_aurl = m_str_burl + m_str_aid;
	}
	return m_str_aurl;
}

double Cq2chwmListItem::GetCountPerDay()
{
	if (m_dbl_count_per_day == -1) {
		m_dbl_count_per_day = (double)((double)GetCount() / (double)(time(NULL) - m_str_aid.Atoi()) * (double)60 * (double)60 * (double)24);
	}
	return m_dbl_count_per_day;
}
